










!m  Program Name:
!  Author(s)/Contact(s): Wei Yu
! 
!  User controllable options: <if applicable>

program data_hydro
! This is the main program of data hydrology model 

   use module_dhydro, only: dhydro_ini, dhydro_exe, dabiaLoop, interFace_drv0,interFace_drv
   use module_namelist, only: nlst_rt
   use module_channelUpdate, only:  bias2m
   use module_rami_hybridDa, only: segInfoFile
   use module_mpp_land, only: my_id, io_id, global_rt_nx, global_rt_ny
   use module_noahmp_hrldas_driver, only: land_driver_ini, land_driver_exe, olddate
   use module_dhydro, only : factor, dhydro_adjust
   use module_RT_data, only: rt_domain
   
   

   implicit none

   integer :: k, dabiaLoopOpt, did, mLoop
   integer :: ITIME, NTIME

   parameter(did = 1)
   character(len=1) ss
   



!   print*, " DABE = ", nlst_rt(did)%DABE, "dabiaLoop = ", dabiaLoop
!yw   call land_driver_ini(NTIME)

   call interFace_drv()

   call dhydro_ini()

  write(6,*) "step 1  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt


   if(nlst_rt(did)%DABE .eq. 0) dabiaLoop = 0

   write(6,*) " DABE = ", nlst_rt(did)%DABE, "dabiaLoop = ", dabiaLoop

   if(dabiaLoop .gt. 0 .or. dabiaLoop .lt. 0) call daBiaLoop_ini_drv()

   mLoop = 0
   if(dabiaLoop .gt. 0) mLoop = dabiaLoop

   write(6,*) "step 2  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt


   do k = 0, mLoop
       if(my_id .eq. io_id) then
          write(ss,"(I1)") k
          call system("mkdir "//ss)
          call system("cp "//trim(segInfoFile)//" "//ss)
          call system("cp factor.nc "//ss)
       endif

       call resetIni()

   write(6,*) "step 3  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt
!!!! run NoahMP
       call interFace_drv0()

       RT_DOMAIN(did)%initialized = .false.
       call land_driver_ini(NTIME)
   write(6,*) "step 4  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt
       write(6,*) "after land_driver_ini ", NTIME, mLoop
       call flush(6)


       call aggFactor(k)
      
       write(6,*) "before land_driver_exe, ntime, dhydroFlag ", NTIME, nlst_rt(did)%dhydroFlag
       call flush(6)

!!       call readCHNC_drv()

       do ITIME = 1, NTIME
!!         call readCHNC_drv()
           call land_driver_exe(ITIME)

           call dhydro_adjust(olddate,ITIME)
       end do

       call interFace_drv()

       write(6,*) "after land_driver_exe ", NTIME
       call flush(6)


       !! call dhydro_exe()

       if(dabiaLoop .gt. 0 .or. dabiaLoop .lt. 0) call dumpPair_drv(k)
       if( k .ne. mLoop .or. dabiaLoop .ne. 0) then
          call daBiaRun_drv(k,dabiaLoop)
       endif
   enddo
   call hydro_finish()
END 


      subroutine aggFactor(unit)
        stop "Error: please compile the code with WRF_DHYDRO=1"

      end subroutine aggFactor
